; layered parent for console window (cmd.exe) // draft v.2007-02-04

.386
.model	flat,stdcall
option	casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32
inclib  shell32

.data
newparent	db "cmdparent",0,"draft v.2007-02-04, by kero <geocities.com/xmemor>",0
filename	db "cmd.exe",0
classname	db "ConsoleWindowClass",0
timerid		dd 1

.data?   	
hinst			HINSTANCE ?
hwin			HWND ?
zoomed_		dd ?

.code

EnWin proc hWnd:HWND,param:DWORD
	invoke GetWindow,hWnd,GW_OWNER
	.if eax==param
		invoke GetWindowLong,hWnd,GWL_EXSTYLE
		and eax,WS_EX_TOPMOST
		.if eax==0
			invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED ; OR SWP_NOSENDCHANGING
		.endif
	.endif
	mov eax,TRUE
	ret
EnWin endp


WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local rt:RECT
	local rc:RECT
	local buf[MAX_PATH]:BYTE
	local sui:STARTUPINFO
	local pi:PROCESS_INFORMATION 

	.if uMsg==WM_DESTROY
		invoke KillTimer,hWnd,timerid
;		invoke PostMessage      ,hwin,WM_CLOSE,0,0
		invoke SendNotifyMessage,hwin,WM_CLOSE,0,0
		invoke PostQuitMessage,0

	.elseif uMsg==WM_CREATE
		invoke ShellExecute,0,0,offset filename,0,0,SW_HIDE
@@:
		invoke Sleep,10
		invoke FindWindow,offset classname,0
		test eax,eax
		jz @b
		mov hwin,eax
		invoke SetWindowPos,hwin,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
		invoke GetWindowRect,hwin,addr rt
		invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,rt.right,rt.bottom,SWP_FRAMECHANGED
		invoke DefWindowProc,hwin,WM_GETTEXT,MAX_PATH-1,addr buf
		invoke DefWindowProc,hWnd,WM_SETTEXT,0,addr buf
		invoke DefWindowProc,hwin,WM_GETICON,1,0
		invoke DefWindowProc,hWnd,WM_SETICON,1,eax
		invoke SetParent,hwin,hWnd
		invoke ShowWindow,hwin,SW_SHOWNORMAL
		invoke SetLayeredWindowAttributes,hWnd,0,128,LWA_ALPHA
		invoke SetTimer,hWnd,timerid,40,0

	.elseif uMsg==WM_TIMER
		invoke IsWindow,hwin
		.if eax==0
			invoke DestroyWindow,hWnd
		.endif
		invoke GetForegroundWindow
		.if eax==hWnd
;			invoke PostMessage      ,hwin,WM_NCACTIVATE,1,0
			invoke SendNotifyMessage,hwin,WM_NCACTIVATE,1,0
		.endif
		invoke GetWindowLong,hWnd,GWL_EXSTYLE
		and eax,WS_EX_TOPMOST
		.if eax!=0
			invoke EnumWindows,offset EnWin,hwin
		.endif
		invoke IsIconic,hwin
		push eax
		invoke IsIconic,hWnd
		pop ecx
		.if eax==0 && ecx!=0
			invoke ShowWindow,hWnd,SW_MINIMIZE
			invoke ShowWindow,hwin,SW_RESTORE
			jmp @@@
		.elseif eax!=0
			jmp @@@
		.endif
		invoke IsZoomed,hwin
		.if eax!=0 && zoomed_==0
			mov zoomed_,1
			jmp @f
		.elseif eax==0 && zoomed_!=0
			mov zoomed_,0
@@:
			invoke GetWindowRect,hwin,addr rc
			mov eax,rc.right
			sub eax,rc.left
			mov ecx,rc.bottom
			sub ecx,rc.top
			invoke SetWindowPos,hWnd,0,0,0,eax,ecx,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED
			invoke SetWindowPos,hwin,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
			jmp @@@
		.endif
		invoke GetWindowRect,hWnd,addr rt
		invoke GetWindowRect,hwin,addr rc
		invoke EqualRect,addr rt,addr rc
		.if eax==0
			mov eax,rc.right
			sub eax,rc.left
			mov ecx,rc.bottom
			sub ecx,rc.top
			invoke SetWindowPos,hWnd,0,rc.left,rc.top,eax,ecx,SWP_NOZORDER OR SWP_FRAMECHANGED
			invoke SetWindowPos,hwin,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
			invoke InvalidateRect,0,0,1
		.endif

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
@@@:
	xor eax,eax
	ret
WndProc endp


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local msg:MSG
	local hwnd:HWND

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,0
	mov wc.lpfnWndProc, offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset newparent
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,WS_EX_LAYERED,\
												offset newparent,0,\
												WS_POPUP OR WS_SYSMENU OR WS_MINIMIZEBOX OR WS_CLIPCHILDREN,\
												0,0,0,0,0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,CmdShow
	invoke UpdateWindow,hwnd
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp


start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start
